---
title: Element.attachShadow()
slug: Web/API/Element/attachShadow
tags:
  - API
  - Element
  - Method
  - Reference
  - attachShadow
  - shadow dom
---
<div>{{APIRef('Shadow DOM')}}</div>

<p>The <strong><code>Element.attachShadow()</code></strong> method attaches a shadow DOM tree to the specified element and returns a reference to its {{domxref("ShadowRoot")}}.</p>

<h2 id="Elements_you_can_attach_a_shadow_to">Elements you can attach a shadow to</h2>

<p>Note that you can't attach a shadow root to every type of element. There are some that can't have a shadow DOM for security reasons (for example {{htmlelement("a")}}), and more besides. The following is a list of elements you <strong>can</strong> attach a shadow root to:</p>

<ul>
 <li>Any autonomous custom element with a <a href="https://html.spec.whatwg.org/multipage/custom-elements.html#valid-custom-element-name">valid name</a></li>
 <li>{{htmlelement("article")}}</li>
 <li>{{htmlelement("aside")}}</li>
 <li>{{htmlelement("blockquote")}}</li>
 <li>{{htmlelement("body")}}</li>
 <li>{{htmlelement("div")}}</li>
 <li>{{htmlelement("footer")}}</li>
 <li>{{htmlelement("h1")}}</li>
 <li>{{htmlelement("h2")}}</li>
 <li>{{htmlelement("h3")}}</li>
 <li>{{htmlelement("h4")}}</li>
 <li>{{htmlelement("h5")}}</li>
 <li>{{htmlelement("h6")}}</li>
 <li>{{htmlelement("header")}}</li>
 <li>{{htmlelement("main")}}</li>
 <li>{{htmlelement("nav")}}</li>
 <li>{{htmlelement("p")}}</li>
 <li>{{htmlelement("section")}}</li>
 <li>{{htmlelement("span")}}</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>shadowroot</var> = <var>element</var>.attachShadow(<var>shadowRootInit</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>shadowRootInit</code></dt>
 <dd>A <code>ShadowRootInit</code> dictionary, which can contain the following fields:
 <dl>
  <dt><code>mode</code></dt>
  <dd>
  <p>A string specifying the <em>encapsulation mode</em> for the shadow DOM tree. This can be one of:</p>

  <ul>
   <li><code>open</code>: Elements of the shadow root are accessible from JavaScript outside the root, for example using {{domxref("Element.shadowRoot")}}:<br>

    <pre>element.shadowRoot; // Returns a ShadowRoot obj</pre>
   </li>
   <li><code>closed</code>: Denies access to the node(s) of a closed shadow root from JavaScript outside it:<br>

    <pre>element.shadowRoot; // Returns null
</pre>
   </li>
  </ul>
  </dd>
  <dt><code>delegatesFocus</code></dt>
  <dd>A boolean that, when set to <code>true</code>, specifies behavior that mitigates custom element issues around focusability. When a non-focusable part of the shadow DOM is clicked, the first focusable part is given focus, and the shadow host is given any available <code>:focus</code> styling.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Returns a {{domxref("ShadowRoot")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The element you are trying to attach to is already a shadow host.</td>
  </tr>
  <tr>
   <td><code>NotSupportedError</code></td>
   <td>You are trying to attach a shadow root to an element outside the HTML namespace, or the element cannot have a shadow attached to it (see above).</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>The following example is taken from our <a href="https://github.com/mdn/web-components-examples/tree/master/word-count-web-component">word-count-web-component</a> demo (<a href="https://mdn.github.io/web-components-examples/word-count-web-component/">see it live also</a>). You can see that we use <code>attachShadow()</code> in the middle of the code to create a shadow root, which we then attach our custom element's contents to.</p>

<pre class="brush: js">// Create a class for the element
class WordCount extends HTMLParagraphElement {
  constructor() {
    // Always call super first in constructor
    super();

    // count words in element's parent element
    var wcParent = this.parentNode;

    function countWords(node){
      var text = node.innerText || node.textContent
      return text.trim().split(/\s+/g).length;
    }

    var count = 'Words: ' + countWords(wcParent);

    // Create a shadow root
    var shadow = this.attachShadow({mode: 'open'});

    // Create text node and add word count to it
    var text = document.createElement('span');
    text.textContent = count;

    // Append it to the shadow root
    shadow.appendChild(text);

    // Update count when element content changes
    setInterval(function() {
      var count = 'Words: ' + countWords(wcParent);
      text.textContent = count;
    }, 200)
  }
}

// Define the new element
customElements.define('word-count', WordCount, { extends: 'p' });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-attachshadow', 'attachShadow()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.attachShadow")}}</p>
